	__config  _CP_OFF & _XT_OSC & _WDT_OFF & _PWRTE_ON & _LVP_OFF & _BODEN_OFF

	#include "P16F873A.INC"  			  ;Include header file 
	
	
BUFFER_INDIRIZZO	EQU			H'20'	  ;buffer per variabili.	
BUFFER_DATO		EQU			H'21'	  ;buffer per variabili.
FLAG				EQU			H'22'	  ;buffer per variabili. 
BUFFER_INDI_E		EQU			H'23'	  ;buffer per variabili.
BUFFER_DATO_1		EQU			H'24'       ;buffer per variabili.
BUFFER_DATO_2		EQU			H'25' 	  ;buffer per variabili.
FLAG_1			EQU			H'26'
BUFFER_SEGMENT		EQU			H'27'
	
INDIRIZZO_TX		EQU			B'11000000' ;indirizzo slave per scrittura.
INDIRIZZO_RX		EQU			B'11000001' ;indirizzo slave per lettura.	
DATO_TX			EQU 			B'10101001' ;dato da trasmettere allo slave.
CLOCK_50_Khz		EQU			B'00010011' ;frequenza SCL 50 KHz con freq. osc. 4 MHz.
CLOCK_100_Khz		EQU			B'00001001' ;frequenza SCL 100 KHz con freq. osc. 4 MHz.

DATA_1			EQU			B'00101001' ;5 byte da spedire al Tea.
DATA_2			EQU			B'11100000' ;   "			"
DATA_3			EQU			B'11111000' ;   "			"	  
DATA_4			EQU			B'00011011' ;   "			"
DATA_5			EQU			B'01000000' ;   "			"


	ORG		0x000			;Program starts at 0x000 	
	GOTO		INIZIO			;
	
SCRITTURA_EEPROM	
	BCF      	STATUS,RP0   		;RAM bank 0.     
     MOVF 	BUFFER_INDIRIZZO,0	;carica in W il valore indirizzo della cella EEPROM 
     						;contenente il dato da leggere.
	BCF      	STATUS,RP0   		;RAM  
	BSF 		STATUS, RP1		;Bank 2
	MOVWF 	EEADR 			;write to
	MOVF 	BUFFER_DATO,W 	     ;Data to
	MOVWF     EEDATA 			;write
	
	BSF		 STATUS,RP0		;Bank 3
	BCF		 EECON1,EEPGD		;Point to Data memory
	BSF 		 EECON1,WREN 		;Enable writes

	MOVLW 	0x55 			;Write 55h to
	MOVWF 	EECON2 			;EECON2
	MOVLW 	0xAA 			;Write AAh to
	MOVWF 	EECON2 			;EECON2
	BSF 		EECON1,WR 		;Start write operation
	BTFSC 	EECON1, WR 		;Wait for
			GOTO $-1 			;write to finish
	BCF 		EECON1,WREN 		;Disable write.
	BCF      	STATUS,RP0   		;RAM  
	BCF 		STATUS,RP1		;Bank 0
	RETLW	0
	
LETTURA_EEPROM
	BCF      	STATUS,RP0   		;RAM bank 0.     
     MOVF 	BUFFER_INDIRIZZO,0	;carica in W il valore indirizzo della cella EEPROM 
     						;contenente il dato da leggere.
	BSF    	STATUS,RP1     	;RAM 
	BCF		STATUS,RP0		;bank 2.
	MOVWF	EEADR			;sposta il contenuto di W nel registro EEADR.
	BSF		STATUS,RP0		;RAM bank 3.
	BCF		EECON1,EEPGD		;punta a data EEPROM.
	BSF		EECON1,RD			;parte la lettura.
	BCF		STATUS,RP0		;RAM bank 2.
	MOVF		EEDATA,W			;in W il dato letto.
	BCF		STATUS,RP0		;RAM
	BCF		STATUS,RP1		;bank 0.
	MOVWF	BUFFER_DATO		;in BUFFER_DATO il dato letto.
	RETLW	0	
	
START	
	BSF    	STATUS,RP0     	;RAM bank 1     
     BSF		SSPCON2,RSEN		;start I^2
     CALL		ATTESA_SSPIF		;attende il completamento dello START;
     RETLW	0				;
     
ATTESA_SSPIF
	BCF      	STATUS,RP0   		;RAM bank 0.
     BTFSS	PIR1,SSPIF		;aspetta che il PIC abbia completato 
     GOTO      ATTESA_SSPIF		;l'operazione.
     BCF		PIR1,SSPIF		;cancella il bit SSPIF.
     RETLW	0				;
      
STOP
	BSF    	STATUS,RP0     	;RAM bank 1
   	BSF		SSPCON2,PEN		;stop I^2
   	CALL 	ATTESA_SSPIF		;attende il completamento dello STOP.     
	RETLW	0
	
TRA_INDIRIZZO
	BCF      	STATUS,RP0   		;RAM bank 0.     
     MOVF 	BUFFER_INDIRIZZO,0	;carica il valore indirizzo nel registro SSPBUF da
     MOVWF	SSPBUF			;spedire allo slave.
     CALL		ATTESA_SSPIF 		;attende il trasferimento dell'indirizzo.     
     BSF    	STATUS,RP0     	;RAM bank 1
     BTFSC	SSPCON2,ACKSTAT 	;se c'e' riconoscimento salta, 
     CALL		NO_RICONOSCIMENTO	;se no FLAG<0>=1.
  	BCF      	STATUS,RP0   		;RAM bank 0.       
     RETLW	0				;
     
NO_RICONOSCIMENTO	  
     BCF      	STATUS,RP0   		;RAM bank 0.
     BSF       FLAG,0			;FLAG<0> = 1.
     MOVLW	B'101111'			;pone la PORTA = 1.
     MOVWF	PORTA			;
LOOP     						;
     GOTO		LOOP				;LOOP indefinito.     
     RETLW	0				;     
     
TRA_DATO          
     BCF      	STATUS,RP0   		;RAM bank 0.
     MOVF 	BUFFER_DATO,0   	;carica il valore dato nel registro SSPBUF da
     MOVWF	SSPBUF			;spedire allo slave.
     CALL		ATTESA_SSPIF		;attende il trasferimento del dato.
     BSF    	STATUS,RP0     	;RAM bank 1
     BTFSC	SSPCON2,ACKSTAT	;se c'e' riconoscimento salta,
     CALL		NO_RICONOSCIMENTO   ;se no esce con il registro FLAG<0> = 1. 
     BCF      	STATUS,RP0   		;RAM bank 0. 
     RETLW	0				;
     
RIC_DATO
	BSF    	STATUS,RP0     	;RAM bank 1	
	BSF		SSPCON2,RCEN		;abilita la ricezione.
	CALL		ATTESA_SSPIF		;attende che sia ricevuto e caricato in SSPBUFF il dato.
	BCF      	STATUS,RP0   		;RAM bank 0.
	MOVF		SSPBUF,0			;carica il dato nel registro BUFFER_DATO.
	MOVWF	BUFFER_DATO		; 
	BSF    	STATUS,RP0     	;RAM bank 1
	BCF		SSPCON2,ACKDT		;la pic manda il riconoscimento
	BSF		SSPCON2,ACKEN    	;   "			"
	CALL		ATTESA_SSPIF		;attende il trasferimento del dato.
     BCF      	STATUS,RP0   		;RAM bank 0.     
	RETLW	0 

RIC_DATO_END
	BSF    	STATUS,RP0     	;RAM bank 1	
	BSF		SSPCON2,RCEN		;abilita la ricezione.
	CALL		ATTESA_SSPIF		;attende che sia ricevuto e caricato in SSPBUFF il dato.
	BCF      	STATUS,RP0   		;RAM bank 0.
	MOVF		SSPBUF,0			;carica il dato nel registro BUFFER_DATO.
	MOVWF	BUFFER_DATO		; 
	BSF    	STATUS,RP0     	;RAM bank 1
	BSF		SSPCON2,ACKDT		;la pic non manda il riconoscimento.
	BSF		SSPCON2,ACKEN    	;   "			"
	CALL		ATTESA_SSPIF		;attende il trasferimento del dato.
     BCF      	STATUS,RP0   		;RAM bank 0.     
	RETLW	0 
	
	
RITARDO
	BCF      	STATUS,RP0   		;RAM bank 0. 
	CLRF		TMR0	
T0_OVFL_WAIT
	BTFSS INTCON, T0IF
	GOTO T0_OVFL_WAIT
	CLRF INTCON
	RETLW	0	 				

INIZIO 	
	CLRF		INTCON 			;disabilita tutti gli interrupt.
	MOVLW	H'FF'
	MOVWF	PORTA			;cancella latch PORTA.
	CLRF      PORTB			;cancella latch PORTB.
	CLRF		FLAG				;azzera il buffer flag.
	BSF    	STATUS,RP0    	     ;RAM bank 1
	MOVLW	B'111111'			;pone PORTA come uscita.
	MOVWF	TRISA			; 
	MOVLW	B'11110000'		;pone PORTA come uscita.
	MOVWF	TRISB		
	MOVLW	B'11111111'		;la porta C come ingresso.
	MOVWF	TRISC	     	;
	MOVLW    	0X006 			;All pins digital I/O. 
	MOVWF    	ADCON1      		; 
	MOVLW	CLOCK_50_Khz		;frequenza SCL 50 KHz.
     MOVWF	SSPADD     		;   
     MOVLW     B'00000111'      	;
     MOVWF	OPTION_REG		;
     BCF      	STATUS,RP0   		;RAM bank 0.
     MOVLW	B'00101000'		;abilita RC3 come SCL, e RC4 come SDA per il funzionamento I^2.
     MOVWF	SSPCON         	; 
        
     MOVLW 	H'8'		     	;in W l'indirizzo della cella della EEPROM da leggere.
     MOVWF	BUFFER_INDIRIZZO	;da W nel BUFFER_INDIRIZZO.   
     CALL 	LETTURA_EEPROM		;
     MOVF		BUFFER_DATO,0	     ;nel registro BUFFER_DATO c'e' il dato ricevuto dalla 
     						;EEPROM.
     MOVWF 	BUFFER_INDI_E		;1^dato.  
     
     MOVLW 	H'9'			     ;in W l'indirizzo della cella della EEPROM da leggere.
     MOVWF	BUFFER_INDIRIZZO	;da W nel BUFFER_INDIRIZZO.   
     CALL 	LETTURA_EEPROM		;
     MOVF		BUFFER_DATO,0	     ;nel registro BUFFER_DATO c'e' il dato ricevuto dalla 
     						;EEPROM.
     MOVWF 	BUFFER_SEGMENT		;display dato.   
                 
	BCF		STATUS,2			;azzera il bit z dello status.	
	GOTO		TRA_INDIRIZZO_RIC_DATO_EE	
	
LOOP_PORTA_1
	BCF      	STATUS,RP0   		;RAM bank 0.
	BTFSS	PORTA,0
	GOTO      LOOP_PORTA_1
LOOP_PORTA     	
     
     BTFSS	PORTA,0			;se il tasto stazione up non e' premuto, attende.
     GOTO		CONTROLLO_RB0  	
     GOTO		LOOP_PORTA
		    
CONTROLLO_RB0    
	INCF		BUFFER_SEGMENT,1
	INCF		BUFFER_INDI_E,1			;routine che controlla se si  arrivati all'indirizzo corrispondente
     MOVLW	H'8'		     			;all'ultima stazione (Radio 24). Nel caso sintonizza la tazione sulla
     SUBWF	BUFFER_INDI_E,0			;frequenza RAI 1 (87.6 mHZ)
     BTFSS	STATUS,2					;scrive inoltre l'indirizzo della cella per l'accensione.
     GOTO		TRA_INDIRIZZO_RICEZIONE_DATO_EE	;   "			"
     CLRF      BUFFER_INDI_E				;   "			"    
     MOVLW	H'0A'
     MOVWF	BUFFER_SEGMENT
     BCF		STATUS,2					;   "			"	;   "			"	
     	
TRA_INDIRIZZO_RICEZIONE_DATO_EE
;ROUTINE PER SCRIVERE IL DATO CONTENUTO NELLA EEPROM DELLA PIC:
;Trasmette l'indirizzo (contenuto nel registro INDIRIZZO_TX) alla EEPROM della PIC e scrive il
;dato che e' l'indirizzo della cella che contiene il 1^ dato per il pll del tea.


     MOVLW	H'8'
     MOVWF     BUFFER_INDIRIZZO
     MOVF 	BUFFER_INDI_E,W
     MOVWF	BUFFER_DATO
     CALL	     SCRITTURA_EEPROM  
     
     MOVLW	H'9'
     MOVWF     BUFFER_INDIRIZZO
     MOVF 	BUFFER_SEGMENT,W
     MOVWF	BUFFER_DATO
     CALL	     SCRITTURA_EEPROM  

     
;ROUTINE PER LEGGERE IL DATO CONTENUTO NELLA EEPROM DELLA PIC:
;Trasmette l'indirizzo (contenuto nel registro INDIRIZZO_TX) alla EEPROM della PIC e legge il
;dato contenuto in esso, che e' il valore per il PLL del tea.
;Ogni valore e' di 14 bit, e prende quindi 2 celle da 8 bit.
	
TRA_INDIRIZZO_RIC_DATO_EE	
	MOVF 	BUFFER_INDI_E,0	;in W l'indirizzo della cella della EEPROM da leggere.
     MOVWF	BUFFER_INDIRIZZO	;da W nel BUFFER_INDIRIZZO.   
     CALL 	LETTURA_EEPROM		;
     MOVF		BUFFER_DATO,0	     ;nel registro BUFFER_DATO c'e' il dato ricevuto dalla 
     						;EEPROM.
     MOVWF	BUFFER_DATO_1		;1^dato.
     					
     INCF		BUFFER_INDI_E,1	;2^ cella.					
     						
	MOVF      BUFFER_INDI_E,0	;in W l'indirizzo della cella della EEPROM da leggere.
     MOVWF	BUFFER_INDIRIZZO	;da W nel BUFFER_INDIRIZZO.   
     CALL 	LETTURA_EEPROM		;
     MOVF		BUFFER_DATO,0	     ;nel registro BUFFER_DATO c'e' il 2^ dato ricevuto dalla 
     						;EEPROM.   
     MOVWF	BUFFER_DATO_2		
     
;Routine per leggere il dato dalla eeprom e scriverlo sul display.     
     MOVF 	BUFFER_SEGMENT,0	;in W l'indirizzo della cella della EEPROM da leggere.
     MOVWF	BUFFER_INDIRIZZO	;da W nel BUFFER_INDIRIZZO.   
     CALL 	LETTURA_EEPROM		;
     MOVF		BUFFER_DATO,0	     ;nel registro BUFFER_DATO c'e' il dato ricevuto dalla 
     						;EEPROM.   						
    	
     MOVWF	PORTB  

     
     
;ROUTINE:     
;Trasmette l'indirizzo (contenuto nel registro INDIRIZZO_TX) e  il dato
;(contenuto nel registro DATO_TX) allo slave TEA.
;Il riconoscimento lo invia sempre lo slave.
;Se il MASTER non riceve il riconoscimento setta il resistro FLAG e tutte le uscite della
;porta A, e il programma si blocca.      				 						
     						         
   	
     CALL		START			;avvia lo START.
     
     MOVLW	INDIRIZZO_TX		;nel buffer l'indirizzo dello slave.
     MOVWF	BUFFER_INDIRIZZO	;   
     CALL 	TRA_INDIRIZZO		;trasmette l'indirizzo.   
     
     MOVF 	BUFFER_DATO_1,0		;carica il registro BUFFER_DATO con il contenuto
     MOVWF	BUFFER_DATO		;del registro DATO_TX (dato da trasmettere).
     CALL      TRA_DATO			;trasmette il dato.
     
     MOVF 	BUFFER_DATO_2,0	;carica il registro BUFFER_DATO con il contenuto
     MOVWF	BUFFER_DATO		;del registro DATO_TX (dato da trasmettere).
     CALL      TRA_DATO			;trasmette il dato.  
     
     
     MOVLW	DATA_3			;carica il registro BUFFER_DATO con il contenuto
     MOVWF	BUFFER_DATO		;del registro DATO_TX (dato da trasmettere).
     CALL      TRA_DATO			;trasmette il dato.  
     
     MOVLW	DATA_4			;carica il registro BUFFER_DATO con il contenuto
     MOVWF	BUFFER_DATO		;del registro DATO_TX (dato da trasmettere).
     CALL      TRA_DATO			;trasmette il dato.  
     
     MOVLW	DATA_5			;carica il registro BUFFER_DATO con il contenuto
     MOVWF	BUFFER_DATO		;del registro DATO_TX (dato da trasmettere).
     CALL      TRA_DATO			;trasmette il dato.      
     
     CALL		STOP         		;avvia lo STOP.  
          
     CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	
  	GOTO		LOOP_PORTA_1	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
  	
	
	BTFSS	FLAG_1,0
	GOTO		RESETTA	
	
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	CALL		RITARDO			;routine per dare un po' di spazio temporale tra start e stop.
	
RESETTA	
	BCF		FLAG_1,0

	
		
	
;ROUTINE:     
;Trasmette l'indirizzo (contenuto nel registro INDIRIZZO_TX) allo slave TEA e riceve il dato
;(nel registro BUFFER_DATO) dallo slave.
;Il riconoscimento lo invia sempre lo slave.
;Se il MASTER non riceve il riconoscimento setta il resistro FLAG e tutte le uscite della
;porta A, e il programma si blocca.            
     
TRA_INDIRIZZO_RICEZIONE_DATO_P      
     CALL		START			;avvia lo START.
     
     MOVLW	INDIRIZZO_RX		;nel buffer l'indirizzo dello slave.
     MOVWF	BUFFER_INDIRIZZO	;   
     CALL 	TRA_INDIRIZZO		;trasmette l'indirizzo.
     
     CALL      RIC_DATO			;riceve il dato.    
     MOVF		BUFFER_DATO,0		;nel registro BUFFER_DATO c'e' il dato ricevuto dallo slave.  	 
   	
   	CALL      RIC_DATO			;riceve il dato.    
     MOVF		BUFFER_DATO,0		;nel registro BUFFER_DATO c'e' il dato ricevuto dallo slave.      
     
   	CALL      RIC_DATO			;riceve il dato.    
     MOVF		BUFFER_DATO,0		;nel registro BUFFER_DATO c'e' il dato ricevuto dallo slave.    
     BTFSS	BUFFER_DATO,7		;la stazione riscevuta e' mono o stereo?
   	GOTO		AZZERA
   	BCF       PORTA,5 			;stereo.
   	BSF		PORTA,4
   	
LOOP_STEREO
   	CALL      RIC_DATO			;riceve il dato.    
     MOVF		BUFFER_DATO,0		;nel registro BUFFER_DATO c'e' il dato ricevuto dallo slave.    	
   	
   	CALL      RIC_DATO_END  		;riceve il dato con routine che non manda il riconoscimento.    
     MOVF		BUFFER_DATO,0		;nel registro BUFFER_DATO c'e' il dato ricevuto dallo slave.     	  	 		
   	
     CALL		STOP         		;avvia lo STOP.
      
     GOTO		LOOP_PORTA   
     
AZZERA
	BSF		PORTA,5			;mono.
	BCF		PORTA,4
	GOTO		LOOP_STEREO

	END   
								   
